## 5585번 거스름 돈 (Bronze )

문제
타로는 자주 JOI잡화점에서 물건을 산다. JOI잡화점에는 잔돈으로 500엔, 100엔, 50엔, 10엔, 5엔, 1엔이 충분히 있고, 언제나 거스름돈 개수가 가장 적게 잔돈을 준다. 타로가 JOI잡화점에서 물건을 사고 카운터에서 1000엔 지폐를 한장 냈을 때, 받을 잔돈에 포함된 잔돈의 개수를 구하는 프로그램을 작성하시오.

예를 들어 입력된 예1의 경우에는 아래 그림에서 처럼 4개를 출력해야 한다.

입력
입력은 한줄로 이루어져있고, 타로가 지불할 돈(1 이상 1000미만의 정수) 1개가 쓰여져있다.

출력
제출할 출력 파일은 1행으로만 되어 있다. 잔돈에 포함된 매수를 출력하시오.

예제 입력 1 
380
예제 출력 1 
4

출처 : 백준 5585번,  https://www.acmicpc.net/problem/5585

## 내가 푼 코드

```
[메모리 : 18168KB, 시간 : 236ms]

import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int exchange = 1000 - sc.nextInt();

        int count = 0;
        while(exchange >= 1){
            if(exchange >= 500){
                exchange -= 500;
                count++;
            } else if(exchange >= 100){
                exchange -= 100;
                count++;
            } else if(exchange >= 50){
                exchange -= 50;
                count++;
            } else if(exchange >= 10){
                exchange -= 10;
                count++;
            } else if(exchange >= 5){
                exchange -= 5;
                count++;
            } else{
                exchange -= 1;
                count++;
            }
        }
        System.out.println(count);
    }
}

```

## 개선 할 수 있는 코드

배열을 사용하여 돈을 저장하고, 가격을 탐욕적으로 취하는 방법을 아래와 같이 처리할 수 있다.

몫을 통한 count 계산 : `cnt = cnt + total/Coins[i];`  
나머지로 남은 금액 계산 : `total %= Coins[i];`

이렇게 하면 한번의 반복으로 계산을 처리할 수 있다.

```
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
public class Main {

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int total = 1000;
	    int Coins[] = {500, 100, 50, 10, 5, 1};
		int cnt = 0;
		int pay = Integer.parseInt(br.readLine());
		
		if(pay >= 1 && pay <= 1000) {
			total -= pay;
			for(int i = 0; i <= Coins.length-1; i++) {
				if(Coins[i] <= total) {
					cnt = cnt + total/Coins[i];
					total %= Coins[i];
				}
			}
		}
		System.out.println(cnt);
	}
}
```